﻿using System;
using System.Collections.Generic;
using System.Text;

namespace cccXML
{

    // ソフトウェア ツリービューのノードが持つ情報
    // xml読み込み時に取得、出力時に設定
    class Node情報
    {
        public string name;     // if / 行動 タグ名称 (TreeViewのラベルはこの値を使用する)

        // ifノード 属性
        // <if L="ゲームカウント" o="==" R="0" comm="コメント1">
        public string L;
        public string o;
        public string R;

        // 行動ノード 属性
/*
		<!-- 1.数値:x,y,z座標(絶対座標) -->
		<行動 x="1" y="2" z="3" />

		<!-- 2.座標を表す規定の文字列 (行動ノード変数) -->
		<行動 座標="相手座標" />

		<!-- 4.座標を表す規定の文字列 (行動ノード係数付変数) + 係数(数値) -->
		<行動 座標="相手後座標" 係数="3" />
*/
        public string x;
        public string y;
        public string z;
        public string 座標;
        public string 係数;

        public string comm;    // コメント属性 ( if/行動ノード 共通 )

        // --------------------------------------------------------------------
        // ゲーム進行用変数
        // 行動ノード
        public int 行動ノードパターン;

        public float fx;
        public float fy;
        public float fz;

        public float f係数;


        public int index行動ノード変数;
        public int index行動ノード係数付変数;

        // ifノード
        public int ifノードパターン;

        public float fL;
        public float fR;

        public int indexL;  // 左辺式
        public int indexR;  // 右辺式

        public int index_o; // 演算子

        public string ErrMsg;



        public Node情報()
        {
            name = "";

            // ifノード属性
            L = "";
            o = "";
            R = "";

            // 行動ノード属性
            x = "";
            y = "";
            z = "";
            座標 = "";
            係数 = "";

            // 共通属性
            comm = "";

            // ゲーム進行用変数
            // --------------------------
            // 行動ノード
            行動ノードパターン = 0;

            fx = 0;
            fy = 0;
            fz = 0;

            f係数 = 0;

            index行動ノード変数 = 0;
            index行動ノード係数付変数 = 0;

            // --------------------------
            // ifノード
            ifノードパターン = 0;

            fL = 0;
            fR = 0;
            indexL = 0;
            indexR = 0;
            index_o = 0;

            // --------------------------
            // ビルド時に検出されたエラー
            ErrMsg = "";
        }






        /// <summary>
        /// クラスをディープコピー
        /// </summary>
        public object Clone()
        {
            return new Node情報(this);
        }

        /// <summary>
        /// ディープコピーコンストラクタ
        /// </summary>
        /// <param name="sc"></param>
        public Node情報(Node情報 sc)
        {
            name = sc.name;

            // ifノード属性
            L = sc.L;
            o = sc.o;
            R = sc.R;

            // 行動ノード属性
            x = sc.x;
            y = sc.y;
            z = sc.z;
            座標 = sc.座標;
            係数 = sc.係数;

            // 共通属性
            comm = sc.comm;

            // ゲーム進行用変数 (Clone対象外)
            // --------------------------
            // 行動ノード
            行動ノードパターン = 0;

            fx = 0;
            fy = 0;
            fz = 0;

            f係数 = 0;

            index行動ノード変数 = 0;
            index行動ノード係数付変数 = 0;

            // --------------------------
            // ifノード
            ifノードパターン = 0;

            fL = 0;
            fR = 0;
            indexL = 0;
            indexR = 0;
            index_o = 0;

            // --------------------------
            // ビルド時に検出されたエラー
            ErrMsg = "";    // Clone対象外
        }





    }
}
