﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ccc2
{
    public partial class ゲーム設定 : Form
    {
        public config m_config = new config();

        public ゲーム設定( config config )
        {
            InitializeComponent();

            this.m_config = (config)config.Clone(); // ディープコピー(オリジナルは保存)

            // -----------------------------
            if ( 0 == m_config.iコアルール )
            {
                this.radioButton1.Checked = true;
            }
            else if ( 1 == m_config.iコアルール )
            {
                this.radioButton2.Checked = true;
            }

            // -----------------------------
            if (5400 == m_config.iゲームカウント)
            {
                this.radioButton3.Checked = true;
            }
            else
            {
                this.radioButton4.Checked = true;
            }

            // -----------------------------
            switch (m_config.i軌跡長)
            {
                case 100:
                    this.radioButton5.Checked = true;
                    break;
                case 200:
                    this.radioButton6.Checked = true;
                    break;
                case 300:
                    this.radioButton7.Checked = true;
                    break;
                case 400:
                    this.radioButton8.Checked = true;
                    break;
                default:    // 5400
                    this.radioButton9.Checked = true;
                    break;
            }
        
        }



        // TopMostの設定
        // フルスクリーンの場合TopMost=trueに
        public void SetTopMost(bool top)
        {
            this.TopMost = top;
        }


        
        
        // OKボタン処理
        private void button1_Click(object sender, EventArgs e)
        {
            string msg = "";

            // コアルール
            foreach (RadioButton rb1 in groupBox1.Controls)
            {
                if (rb1.Checked)
                {
                    msg += "groupBox1では" + rb1.Text + "がチェックされています。\r\n";

                    if ( "0 : コアボーナス取得" == rb1.Text)
                    {
                        this.m_config.iコアルール = 0;
                    }
                    else if ("1 : 墜落(負け)" == rb1.Text)
                    {
                        this.m_config.iコアルール = 1;
                    }
                }
            }

            // ゲームカウント
            foreach (RadioButton rb1 in groupBox2.Controls)
            {
                if (rb1.Checked)
                {
                    msg += "groupBox2では" + rb1.Text + "がチェックされています。\r\n";

                    if ("5400" == rb1.Text)
                    {
                        this.m_config.iゲームカウント = 5400;
                    }
                    else if ("2147483637" == rb1.Text)
                    {
                        this.m_config.iゲームカウント = int.MaxValue - 10;
                    }
                }
            }

            // 軌跡長
            foreach (RadioButton rb1 in groupBox3.Controls)
            {
                if (rb1.Checked)
                {
                    msg += "groupBox3では" + rb1.Text + "がチェックされています。\r\n";

                    this.m_config.i軌跡長 = int.Parse(rb1.Text);    // テキストを文字列に変換
                }
            }

//          MessageBox.Show(msg); 

        }

    
    
    
    
    
    
    
    
    
    
    }
}