//--------------------------------------------------------------------------------------
// File: ccc2.fx
//
// The effect file for the ccc sample.  
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
//--------------------------------------------------------------------------------------


//--------------------------------------------------------------------------------------
// O[oϐ
// Global variables
//--------------------------------------------------------------------------------------
float4x4	worldViewProjection;	// World * View * Projection matrix

// ǉ
float		g_Len;			// Jƌ_̋


struct SphereVS_Input
{
    float4 Pos : POSITION;
	float4 Diffuse	: COLOR0;	// _DiffuseF
};

struct SphereVS_Output
{
    float4 Pos		: POSITION;	// _ʒu
	float4 Diffuse	: COLOR0;	// _DiffuseF
};


// ̕\p O/ʂŐFς
SphereVS_Output SphereVS(	SphereVS_Input Input,
							uniform bool bType ) 

{
    SphereVS_Output Output;
    
    // _ʒuˉeԂɃgXtH[
	Output.Pos = mul( Input.Pos, worldViewProjection );

	// Fϊ̗L
	if( bType )
	{
		if( Output.Pos.z > g_Len )	// g_Len = J̉sʒu
		{
			Output.Diffuse.r = Input.Diffuse.r * 0.7f;
			Output.Diffuse.g = Input.Diffuse.g * 0.7f;
			Output.Diffuse.b = Input.Diffuse.b * 0.7f;
/*
			Output.Diffuse.r = 1;
			Output.Diffuse.g = 0;
			Output.Diffuse.b = 1;
*/			
		}
		else
		{
			Output.Diffuse = Input.Diffuse;
		}

	}
	else
	{
		Output.Diffuse = Input.Diffuse;
	}


    return Output;
}



//--------------------------------------------------------------------------------------
// Techniques
//--------------------------------------------------------------------------------------
// technique RenderSphere
technique RenderSphere
{
    pass P0
    {          
		VertexShader = compile vs_1_1 SphereVS( true );
    }
}


