﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.Samples.DirectX.UtilityToolkit;

namespace cccXML
{
    public partial class ifノード編集ダイアログ : Form
    {

        public ifノード編集ダイアログ( float コア半径, float ワールド半径 )
        {
            InitializeComponent();
            this.label_ワールド半径.Text = "コア半径=" + コア半径.ToString() + " ワールド半径=" + ワールド半径.ToString();
        }

        // ----------------------------
        // コンボボックスで選択された項目により絵を表示
        private void comboBox1_L_SelectedIndexChanged(object sender, EventArgs e)
        {
            ヒント表示(this.comboBox1_L.Text);
        }

        private void comboBox3_R_SelectedIndexChanged(object sender, EventArgs e)
        {
            ヒント表示(this.comboBox3_R.Text);
        }



        // 選択項目に対応した説明を表示
        private void ヒント表示( string comboBoxText  )
        {
            string path = null;

            System.IO.FileStream hStream = null;

            // FileStream を開く
            switch ( comboBoxText )
            {

                case "コアルール":
                    path = Utility.FindMediaFile("img\\ヒントifコアルール.bmp");

                    this.labelヒント.Text = "ユニットがコアに進入\r\nした場合のルール\r\n0 : コアボーナス取得\r\n1 : 墜落(負け)";
                    this.labelヒント.Visible = true;
                    break;

    
                case "敵座標角度(0～180)":
                    path = Utility.FindMediaFile("img\\ヒントif角度.bmp");

                    this.labelヒント.Text = "敵が前方にいる場合:0°\r\n後方にいる場合180°";
                    this.labelヒント.Visible = true;
                    break;

                case "コア座標角度(0～180)":
                    path = Utility.FindMediaFile("img\\ヒントif角度.bmp");

                    this.labelヒント.Text = "コアが前方にある場合:0°\r\n後方にある場合180°";
                    this.labelヒント.Visible = true;
                    break;

                case "敵方向角度(0～180)":
                    path = Utility.FindMediaFile("img\\ヒントif敵方向角度.bmp");

                    this.labelヒント.Text = "敵unitから見て自機が\r\n前方にある場合:0°\r\n(危険)\r\n後方にある場合180°\r\n(安全)";
                    this.labelヒント.Visible = true;
                    break;

                case "敵中心間距離":
                case "自中心間距離":
                    path = Utility.FindMediaFile("img\\ヒントif中心間距離.bmp");

                    this.labelヒント.Text = "コアの中心とunit間の距離";
                    this.labelヒント.Visible = true;
                    break;

                case "自外殻間距離":
                case "敵外殻間距離":
                    path = Utility.FindMediaFile("img\\ヒントif外殻間距離.bmp");

                    this.labelヒント.Text = "外殻とunit間の距離";
                    this.labelヒント.Visible = true;
                    break;

                default:
                    this.labelヒント.Visible = false;
                    break;

            }

            if (null != path)
            {
                hStream = new System.IO.FileStream(path, System.IO.FileMode.Open);

                // FileStream から画像を読み込んで表示
                this.pictureBox1.Image = Image.FromStream(hStream);

                // FileStream を閉じる (正しくは オブジェクトの破棄を保証する を参照)
                hStream.Close();
            }
            else
            {
                // 絵を消去
                this.pictureBox1.Image = null;
            }
        }
    
    
    
    }
}