﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.DirectX;

using Microsoft.Samples.DirectX.UtilityToolkit;

namespace cccXML
{
    public partial class 行動ノード編集ダイアログ : Form
    {


        public 行動ノード編集ダイアログ(float コア半径, float ワールド半径)
        {
            InitializeComponent();
            this.label_ワールド半径.Text = "コア半径=" + コア半径.ToString() + " ワールド半径=" + ワールド半径.ToString();
        }
        
        
        
        private void radioButton直進_Click(object sender, EventArgs e)
        {
            ヒント表示(null); // ヒント表示せず

            if (this.radioButton直進.Checked)
            {
                // xyz座標指定
                this.textBox_x.Enabled = false;
                this.textBox_y.Enabled = false;
                this.textBox_z.Enabled = false;

                // 座標指定
                this.comboBox_座標.Enabled = false;

                // 座標指定+係数
                this.comboBox_係数付座標.Enabled = false;
                this.textBox_係数.Enabled = false;
            }
        }

        private void radioButton_xyz座標指定_Click(object sender, EventArgs e)
        {
            ヒント表示("xyz座標指定");

            if (this.radioButton_xyz座標指定.Checked)
            {
                // xyz座標指定
                this.textBox_x.Enabled = true;
                this.textBox_y.Enabled = true;
                this.textBox_z.Enabled = true;

                // --------------------
                // 座標指定
                this.comboBox_座標.Enabled = false;

                // 座標指定+係数
                this.comboBox_係数付座標.Enabled = false;
                this.textBox_係数.Enabled = false;
            }
        }

        private void radioButton_座標指定_係数_Click(object sender, EventArgs e)
        {
            ヒント表示(null); // ヒント表示せず

            if (this.radioButton_座標指定_係数.Checked)
            {
                // 座標指定+係数
                this.comboBox_係数付座標.Enabled = true;
                this.textBox_係数.Enabled = true;

                // --------------------
                // xyz座標指定
                this.textBox_x.Enabled = false;
                this.textBox_y.Enabled = false;
                this.textBox_z.Enabled = false;

                // 座標指定
                this.comboBox_座標.Enabled = false;
            }
        }

        private void radioButton_座標指定_Click(object sender, EventArgs e)
        {
            ヒント表示(null); // ヒント表示せず

            if (this.radioButton_座標指定.Checked)
            {
                // 座標指定
                this.comboBox_座標.Enabled = true;

                // --------------------
                // xyz座標指定
                this.textBox_x.Enabled = false;
                this.textBox_y.Enabled = false;
                this.textBox_z.Enabled = false;

                // 座標指定+係数
                this.comboBox_係数付座標.Enabled = false;
                this.textBox_係数.Enabled = false;
            }
        }




        private void buttonOK_Click(object sender, EventArgs e)
        {
            // 座標指定方法を指定するラジオボタンに対応する値が入力されていることをチェック
            // ラジオボタンにより指定された値のみを保存。
            if (true == this.radioButton_座標指定.Checked)
            {
                // 座標指定
                if ( "" != this.comboBox_座標.Text )
                {
                    this.comboBox_係数付座標.Text = null;
                    this.textBox_係数.Text = null;

                    this.textBox_x.Text = null;
                    this.textBox_y.Text = null;
                    this.textBox_z.Text = null;

                    this.DialogResult = DialogResult.OK;
                    return;
                }

            }
            else if (true == this.radioButton_座標指定_係数.Checked)
            {
                // 座標指定+係数
                if ( "" != this.comboBox_係数付座標.Text &&
                     "" != this.textBox_係数.Text )
                {
                    this.comboBox_座標.Text = null;

                    this.textBox_x.Text = null;
                    this.textBox_y.Text = null;
                    this.textBox_z.Text = null;

                    this.DialogResult = DialogResult.OK;
                    return;
                }
            }
            else if (true == this.radioButton_xyz座標指定.Checked)
            {
                // xyz座標指定
                if ( "" != this.textBox_x.Text &&
                     "" != this.textBox_y.Text &&
                     "" != this.textBox_z.Text )
                {
                    this.comboBox_座標.Text = null;

                    this.comboBox_係数付座標.Text = null;
                    this.textBox_係数.Text = null;

                    this.DialogResult = DialogResult.OK;
                    return;
                }
            }
            else if (true == this.radioButton直進.Checked)
            {
                this.comboBox_座標.Text = null;

                this.comboBox_係数付座標.Text = null;
                this.textBox_係数.Text = null;

                this.textBox_x.Text = null;
                this.textBox_y.Text = null;
                this.textBox_z.Text = null;

                this.DialogResult = DialogResult.OK;
                return;
            }

            MessageBox.Show("目標が設定されていません。",
                            "行動ノード編集",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Information);
        }

        private void textBox_x_TextChanged(object sender, EventArgs e)
        {
            xyz座標Length();
        }

        private void textBox_y_TextChanged(object sender, EventArgs e)
        {
            xyz座標Length();
        }

        private void textBox_z_TextChanged(object sender, EventArgs e)
        {
            xyz座標Length();
        }

        private void xyz座標Length()
        {

            float fx, fy, fz;

            // x,y,z座標の長さを求める
            if (
                !float.TryParse(this.textBox_x.Text,
                    System.Globalization.NumberStyles.Any,
                    System.Globalization.NumberFormatInfo.InvariantInfo,
                    out fx)
                ||
                !float.TryParse(this.textBox_y.Text,
                    System.Globalization.NumberStyles.Any,
                    System.Globalization.NumberFormatInfo.InvariantInfo,
                    out fy)
                ||
                !float.TryParse(this.textBox_z.Text,
                    System.Globalization.NumberStyles.Any,
                    System.Globalization.NumberFormatInfo.InvariantInfo,
                    out fz))
            {
                // x,y,zのどれかが数値でない。長さを求めることはできない。
            }
            else
            { 
                Vector3 座標 = new Vector3(fx,fy,fz);
                this.label_xyz座標長.Text = "xyz座標長=" + 座標.Length().ToString();
            }

        }


        // ----------------------------
        // コンボボックスで選択された項目により絵を表示
        private void comboBox_座標_TextChanged(object sender, EventArgs e)
        {
            ヒント表示(this.comboBox_座標.Text);
        }

        private void comboBox_係数付座標_TextChanged(object sender, EventArgs e)
        {
            ヒント表示(this.comboBox_係数付座標.Text);
        }





        // 選択項目に対応した説明を表示
        private void ヒント表示(string comboBoxText)
        {
            string path = null;

            System.IO.FileStream hStream = null;

            // FileStream を開く
            switch (comboBoxText)
            {
                case "xyz座標指定": // チェックボックスが押されたときにヒント表示
                    path = Utility.FindMediaFile("img\\ヒント行動xyz座標.bmp");
                    this.labelヒント.Text = "コアを原点にした、\r\nXYZ座標を指定";
                    this.labelヒント.Visible = true;
                    break;


                case "敵反対座標":
                    path = Utility.FindMediaFile("img\\ヒント行動反対座標.bmp");
                    this.labelヒント.Text = "コアを中心にした、\r\n敵unitの反対座標";
                    this.labelヒント.Visible = true;
                    break;

                case "コア反対座標":
                    path = Utility.FindMediaFile("img\\ヒント行動コア反対座標.bmp");
                    this.labelヒント.Text = "コアの反対側の外殻座標。\r\nコアから離れる行動";
                    this.labelヒント.Visible = true;
                    break;

                case "敵前座標":
                case "敵後座標":
                case "敵左座標":
                case "敵右座標":
                case "敵上座標":
                case "敵下座標":
                    path = Utility.FindMediaFile("img\\ヒント行動座標.bmp");
                    this.labelヒント.Text = "敵unitを中心にした座標。\r\n係数分離れる。";
                    this.labelヒント.Visible = true;
                    break;

                case "敵最遠座標":
                    path = Utility.FindMediaFile("img\\ヒント行動座標.bmp");
                    this.labelヒント.Text = "敵unitを中心にした座標の内、\r\n自unitから最も遠い座標。\r\n係数分離れる。";
                    this.labelヒント.Visible = true;
                    break;

                case "敵最近座標":
                    path = Utility.FindMediaFile("img\\ヒント行動座標.bmp");
                    this.labelヒント.Text = "敵unitを中心にした座標の内、\r\n自unitから最も近い座標。\r\n係数分離れる。";
                    this.labelヒント.Visible = true;
                    break;

                case "敵最遠座標(前を除く)":
                    path = Utility.FindMediaFile("img\\ヒント行動座標前除く.bmp");
                    this.labelヒント.Text = "敵unitを中心にした座標の内、\r\n前座標を除いて\r\n自unitから最も遠い座標。\r\n係数分離れる。";
                    this.labelヒント.Visible = true;
                    break;

                case "敵最近座標(前を除く)":
                    path = Utility.FindMediaFile("img\\ヒント行動座標前除く.bmp");
                    this.labelヒント.Text = "敵unitを中心にした座標の内、\r\n前座標を除いて\r\n自unitから最も近い座標。\r\n係数分離れる。";
                    this.labelヒント.Visible = true;
                    break;

                case "敵最遠座標(前後を除く)":
                    path = Utility.FindMediaFile("img\\ヒント行動座標前後除く.bmp");
                    this.labelヒント.Text = "敵unitを中心にした座標の内、\r\n前後座標を除いて\r\n自unitから最も遠い座標。\r\n係数分離れる。";
                    this.labelヒント.Visible = true;
                    break;

                case "敵最近座標(前後を除く)":
                    path = Utility.FindMediaFile("img\\ヒント行動座標前後除く.bmp");
                    this.labelヒント.Text = "敵unitを中心にした座標の内、\r\n前後座標を除いて\r\n自unitから最も近い座標。\r\n係数分離れる。";
                    this.labelヒント.Visible = true;
                    break;

                default:
                    this.labelヒント.Visible = false;
                    break;

            }

            if (null != path)
            {
                hStream = new System.IO.FileStream(path, System.IO.FileMode.Open);

                // FileStream から画像を読み込んで表示
                this.pictureBox1.Image = Image.FromStream(hStream);

                // FileStream を閉じる (正しくは オブジェクトの破棄を保証する を参照)
                hStream.Close();
            }
            else
            {
                // 絵を消去
                this.pictureBox1.Image = null;
            }
        }

        










        
        




    }
}